Page MenuHomePhabricator

Flow: Interwiki exceptions from Special:WhatLinksHere
Closed, ResolvedPublic

Description

It seems asking for WhatLinkshere on one wiki causes exceptions when there are links to it on another wiki.

Happens on enwiki for File:OUYA-Console-set-h.jpg, which I linked on mw.org, also on enwiki for Talk:Sandbox, Template:Bug, etc. But this doesn't happen on meta-wiki which is running the same version, or on mw.org. Confusing.

Perhaps the Flow hook that tries to create a link on WhatLinksHereProp needs to be more robust. Or maybe we need to run maintenance/FlowPopulateLinksTables.php against multiple wikis.

Here's one:

2014-05-29 17:52:55 mw1076 enwiki: [12257f85] /wiki/Special:WhatLinksHere/File:OUYA-Console-set-h.jpg Exception from line 182 of /usr/local/apache/common-local/php-1.24wmf5/extensions/Flow/includes/Model/Workflow.php: Interwiki to mediawikiwiki not implemented
#0 /usr/local/apache/common-local/php-1.24wmf5/extensions/Flow/includes/BaseUrlGenerator.php(171): Flow\Model\Workflow->getArticleTitle()
#1 /usr/local/apache/common-local/php-1.24wmf5/extensions/Flow/includes/UrlGenerator.php(202): Flow\BaseUrlGenerator->resolveTitle(NULL, Object(Flow\Model\UUID))
#2 /usr/local/apache/common-local/php-1.24wmf5/extensions/Flow/includes/ReferenceClarifier.php(50): Flow\UrlGenerator->postLink(NULL, Object(Flow\Model\UUID), Object(Flow\Model\UUID))
#3 /usr/local/apache/common-local/php-1.24wmf5/extensions/Flow/includes/ReferenceClarifier.php(28): Flow\ReferenceClarifier->getObjectLink(Object(Flow\Model\UUID), 'post', Object(Flow\Model\UUID))
#4 /usr/local/apache/common-local/php-1.24wmf5/extensions/Flow/Hooks.php(620): Flow\ReferenceClarifier->getWhatLinksHereProps(Object(stdClass), Object(Title), Object(Title))
#5 [internal function]: FlowHooks::onWhatLinksHereProps(Object(stdClass), Object(Title), Object(Title), Array)
#6 /usr/local/apache/common-local/php-1.24wmf5/includes/Hooks.php(206): call_user_func_array('FlowHooks::onWh...', Array)
#7 /usr/local/apache/common-local/php-1.24wmf5/includes/GlobalFunctions.php(4004): Hooks::run('WhatLinksHerePr...', Array, NULL)
#8 /usr/local/apache/common-local/php-1.24wmf5/includes/specials/SpecialWhatlinkshere.php(329): wfRunHooks('WhatLinksHerePr...', Array)
#9 /usr/local/apache/common-local/php-1.24wmf5/includes/specials/SpecialWhatlinkshere.php(272): SpecialWhatLinksHere->listItem(Object(stdClass), Object(Title), Object(Title))


Version: master
Severity: major
URL: https://en.wikipedia.org/wiki/Special:WhatLinksHere/File:OUYA-Console-set-h.jpg
See Also:
https://bugzilla.wikimedia.org/show_bug.cgi?id=65802

Details

Reference
bz65915

Event Timeline

bzimport raised the priority of this task from to Needs Triage.
bzimport set Reference to bz65915.

bsitu wrote:

It seems that we are loading links by namespace/title pair. If a page with the same namespace/title exists in multitple wikis, this would load unwanted data from other wikis. I think this could be resolved in two steps:

  1. Catch the exception and ignore unrelated reference
  1. Add a wiki field to flow_wiki_ref so only to load reference for the page in current wiki, remove the exception in step 1.

Change 136256 had a related patch set uploaded by Bsitu:
Ignore expected exceptions in WhatLinksHere

https://gerrit.wikimedia.org/r/136256

  • Bug 65802 has been marked as a duplicate of this bug. ***

Change 136280 had a related patch set uploaded by Werdna:
Segregate Reference objects by source wiki.

https://gerrit.wikimedia.org/r/136280

  • Bug 65802 has been marked as a duplicate of this bug. ***

Change 136256 merged by jenkins-bot:
Ignore expected exceptions in WhatLinksHere

https://gerrit.wikimedia.org/r/136256

Change 136932 had a related patch set uploaded by Spage:
Ignore expected exceptions in WhatLinksHere

https://gerrit.wikimedia.org/r/136932

Change 136932 merged by jenkins-bot:
Ignore expected exceptions in WhatLinksHere

https://gerrit.wikimedia.org/r/136932

Change 136933 had a related patch set uploaded by Spage:
Ignore expected exceptions in WhatLinksHere

https://gerrit.wikimedia.org/r/136933

Change 136933 merged by jenkins-bot:
Ignore expected exceptions in WhatLinksHere

https://gerrit.wikimedia.org/r/136933

We're no longer getting these. We're getting Flow Interwiki exceptions from certain Special:Contributions

Quiddity removed a subscriber: Maryana.Dec 19 2014, 1:34 AM

Change 136280 had a related patch set uploaded (by Mattflaschen):
Segregate Reference objects by source wiki.

https://gerrit.wikimedia.org/r/136280

Restricted Application added a project: Collaboration-Team-Triage. · View Herald TranscriptJul 28 2015, 8:30 PM
Catrope reopened this task as Open.Jul 31 2015, 12:45 AM
Catrope added a subscriber: Catrope.

This isn't resolved, the patch was never merged

Restricted Application added a subscriber: Aklapper. · View Herald TranscriptJul 31 2015, 12:45 AM

Change 136280 merged by jenkins-bot:
Segregate Reference objects by source wiki.

https://gerrit.wikimedia.org/r/136280